#ifndef FILETREEVIEW_H_INCLUDED
#define FILETREEVIEW_H_INCLUDED
#include <Wt/WApplication>
#include <Wt/WContainerWidget>
#include <Wt/WStandardItem>
#include <Wt/WStandardItemModel>
#include <boost/filesystem/path.hpp>
#include <Wt/WString>
#include <Wt/WTreeView>
#include <string>
#include <Wt/WText>
#include <deque>


namespace Wt
{
    class WStandardItem;
    class WStandardItemModel;
    class WTreeView;
    class WText;
    class WContainerWidget;
    class WApplication;
}
using namespace Wt;

class PathObject :  WObject
{
public:
    PathObject(boost::filesystem::path path, WObject* parent)
        :m_path(path), m_parent(parent)
    {
    }
    boost::filesystem::path operator()()
    {
        return m_path;
    }
    boost::filesystem::path m_path;
private:
    WObject* m_parent;
};

class FileTreeView : public WTreeView
{
public:
    FileTreeView(const std::string& path, WContainerWidget* parent = NULL);
    bool setPath(const std::string& path);
    bool getCheckedFile(std::string& path);
private:
    typedef std::deque<WStandardItem*> ItemQueue;
    static WStandardItem* checkedItem;
    void itemChanged(WStandardItem* item);
    WContainerWidget   * m_parent;
    WStandardItemModel * m_model;
    std::string          m_path;
};

#endif // FILETREEVIEW_H_INCLUDED
